#!/usr/bin/perl

#TOREMOVE
sub test{
  print SESSION $_[0]; # This is the first parameter given to the subroutine
  my $line = <SESSION>;
  print SESSION $line." --- ";
}

sub create{
  local($error,$username,$realname,$password,$sth);

  $error=0;

  if (($_[0] =~ m/[A-Za-z][A-Za-z0-9]+/) and (length($_[0])<255))  {
    $username=$_[0];
  }else{
    $error=1;
  }

  if ($_[1] =~ m/[^"']*/ and length($_[1])<255)  {
    $realname=$_[1];
  }else{
    $error=1;  
  }

  if ($_[2] =~ m/[-_A-Za-z0-9]+/ and length($_[2])<255)  {
    $password=$_[2];
  }else{
    $error=1;
  }

  if ($error==0){
    my @rows=$dbh->selectrow_array("select count(*) from users where username = '$username'") or die($dbh->errstr);
    if ($rows[0]>0){
	print SESSION "300 USER ALREADY EXISTS\r\n";
    }else{
    	$dbh->do("insert into users (username,realname,password) VALUES ('$username','$realname','$password')");
    	$dbh->commit();  
    	print SESSION "200 USER CREATED\r\n";
    }
  }else{
    print SESSION "400 USER COULD NOT BE CREATED\r\n";
  }
}

#TODO
sub session{
  local($error,$session_id);

  $error=0;

  if (($_[0] =~ m/[A-Za-z0-9]+/) and (length($_[0])<255))  {
    $session_id=$_[0];
  }else{
    $error=1;
  }
	print SESSION $session_id;
  if ($error==0){
    my @id_num = $dbh->selectrow_array("select count(*) from sessions where session_id = '$session_id'") or die($dbh->errstr);

    if($id_num[0] != 0){
      print SESSION "400 SESSION ALREDY EXISTS\n";
    }else{
      $dbh->do("insert into sessions (session_id) VALUES ('$session_id')");
      $dbh->commit();  
      print SESSION "200 SESSION CREATED\n";
    }
  }
  #300 TERMPORARY ERROR 
}

#TODO
sub get{}

#TODO
sub post{}

#TODO
sub dtp{}

use strict;
use Socket;
use IO::Handle;
use constant MY_ECHO_PORT => 8080;
use vars qw($dbh);
use DBI;



# Creating DB connection

my $dbargs = {AutoCommit => 0,
                  PrintError => 1};

our $dbh = DBI->connect("dbi:SQLite:dbname=ws.sqlite","","",$dbargs);



# Creating socket
my ($bytes_out,$bytes_in) = (0,0);

my $port = shift || MY_ECHO_PORT;
my $protocol = getprotobyname('tcp');

$SIG{'INT'} = sub {
    print STDERR "bytes_sent = $bytes_out, bytes_received = $bytes_in\n";
    exit 0;
};

socket(SOCK, AF_INET, SOCK_STREAM, $protocol) or
    die "socket() failed: $!";
setsockopt(SOCK,SOL_SOCKET,SO_REUSEADDR,1) or
    die "Can't set SO_REUSEADDR: $!";

my $my_addr = sockaddr_in($port,INADDR_ANY);
bind(SOCK,$my_addr) or
    die "bind() failed: $!";
listen(SOCK,SOMAXCONN) or
    die "listen() failed: $!";

warn "waiting for incoming connections on port $port...\n";

while(1) {
    next unless my $remote_addr = accept(SESSION,SOCK);
    my ($port,$hisaddr) = sockaddr_in($remote_addr);
    warn "Connection from [",inet_ntoa($hisaddr),",$port]\n";

    SESSION->autoflush(1);
    my $line;
    while($line=<SESSION>) {
    	$bytes_in += length($line);
	    chomp;

      if ($line ne "\r\n"){
      	my @command=split (" ",$line);


        # We call subroutines based on the command
        # The subroutine will then handle the incoming data until it returns
 
        #TOREMOVE
       if ($command[0] eq "TEST"){
          test ($command[1]);
        }

        if ($command[0] eq "CREATE"){
          if ($#command>=3){
            create ($command[1],$command[2],$command[3]);
          }
        }

        if ($command[0] eq "SESSION"){
          session ($command[1]);
        }

        if ($command[0] eq "GET"){
          get ($command[1]);
        }

        if ($command[0] eq "POST"){
          post ($command[1]);
        }

        if ($command[0] eq "DTP"){
          dtp ($command[1]);
        }        
        
      }else{
        close SESSION;
        $dbh->disconnect();
      }
    }

    warn "Connection from [",inet_ntoa($hisaddr),",$port] finished\n";
    close SESSION;
    $dbh->disconnect();
}

