import string,cgi,time,re
from os import curdir, sep, mkdir
import os.path
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
import base64

class MyHandler(BaseHTTPRequestHandler):

	def parse_request(self):
		try:
			if self.expectFile:
				self.command = "UPLOADER"
				return True
		except:
			self.expectFile = False
				
		self.command = None  # set in case of error on the first line
		self.request_version = version = "HTTP20/0" # Default
		self.close_connection = 1
		requestline = self.raw_requestline
		if requestline[-2:] == '\r\n':
			requestline = requestline[:-2]
		elif requestline[-1:] == '\n': 
			requestline = requestline[:-1]
		self.requestline = requestline
		words = requestline.split()
		if len(words) > 2:
			command = words[0]
			path = words
		elif len(words) == 2:
			command = words[0]
			path = words
			self.close_connection = 1
		elif not words:
			return False
		else:
			self.send_error(400, "Bad request syntax (%r)" % requestline)
			return False
		self.command, self.path = command, path
		self.protocol_version = "HTTP20/0"
		self.headers = self.MessageClass(self.rfile, 0)
		conntype = self.headers.get('Connection', "")
		if conntype.lower() == 'close':
			self.close_connection = 1
		else:
			self.close_connection = 0
		fp = open("/tmp/foobar", "a+")
		fp.write("%s %s %s\n" % (time.strftime("%d.%m.%Y %H:%M:%S"), self.client_address, words))
		fp.close()
		print
		print "HEADER: ",
		print self.headers.items()
		return True

	def do_UPLOADER(self):
		print "UPLOADER"
		self.expectFile = False
		#content = self.rfile.readlines()
		#lineNum = len(content)
		newcontent = ""
		for i in range(0,self.FileLines-1):
			newcontent += self.rfile.readline().strip()
		try:
			decoded = base64.b64decode(newcontent)
		except:
			self.send_response(300, "ENCODING ERROR")
			return
		writeFile = "%s/%s" % (self.FilePath, self.FileName)
		#print writeFile
		fp = open(writeFile, 'w')
		fp.writelines(decoded)
		fp.close()
		self.send_response(200, "Thank you, %s, for uploading the file" % (self.FullName))
		self.close_connection = 1
		return

	def check(self, username=None, password=None, fullname=None):
		userRE = re.compile('[A-Za-z][A-Za-z0-9]+')
		nameRE = re.compile('[^"]*')
		passRE = re.compile('[-_A-za-z0-9]+')
		result = []
		if username!=None:
			match = userRE.search(username)
			if match:
				result.append(True)
			else:
				result.append(False)
		if password!=None:
			match = passRE.search(password)
			if match:
				result.append(True)
			else:
				result.append(False)
		if fullname!=None:
			match = nameRE.search(fullname)
			if match:
				result.append(True)
			else:
				result.append(False)
		return result

	def checkPass(self, username, password):
		filename = "/tmp/%s.password" % (username)
		if os.path.exists(filename):
			fp = open(filename, "r")
			content = fp.read().split('"')
			fp.close()
			if password == content[0]:
				return True
		return False

	def getFullname(self, username):
		filename = "/tmp/%s.password" % (username)
		fp = open(filename, "r")
		content = fp.read().split('"')
		fp.close()
		return content[1]

	def do_DTP(self):
		#print "DTP"
		subcommand = self.path[1]
		if subcommand=="MKDIRS":
			if len(self.path)==5:
				username = self.path[2]
				password = self.path[3]
				pfad = self.path[4]
				result = self.check(username, password)
				if False in result:
					self.send_response(100, "INVALID PARAMETERS")
					return
				if not self.checkPass(username, password):
					self.send_response(120, "LOGIN INCORRECT")
					return
				try:
					dirs = pfad.split('/')
					curDir = "/var/www/~%s/" % (username)
					for d in dirs:
						try:
							testDir = "%s%s/" % (curDir, d)
							if not os.path.exists(testDir):
								mkdir("%s%s/" % (curDir, d))
							curDir = "%s%s/" % (curDir, d)
						except:
							continue
					self.send_response(200, "OK")
					return
				except:
					print "failed: %s" % (pfad)
					self.send_response(300, "FAILURE")
					return
			else:
				self.send_response(100, "INVALID PARAMETERS")
				return
		elif subcommand=="DOWNLOAD":
			if len(self.path)==5:
				username = self.path[2]
				password = self.path[3]
				pfad = self.path[4]
				result = self.check(username, password)
				if False in result:
					self.send_response(100, "INVALID PARAMETERS")
					return
				if not self.checkPass(username, password):
					self.send_response(300, "PERMISSION DENIED")
					return
				pfad = "/var/www/~%s/%s" % (username, pfad)
				if not os.path.exists(pfad):
					self.send_response(700, "INVALID PATH")
					return
				try:
					fp = open(pfad, 'r')
					content = fp.readlines()
					fp.close()
					numLines = len(content)
					fullname = self.getFullname(username)
					self.send_response(200, "Thank you, %s, your file is %s line(s) long in encoded form. \n %s" % (fullname, numLines, base64.b64encode("".join(content))))
					return
				except:
					self.send_response(500, "HARD DRIVE FAULTY")
					return
			else:
				self.send_response(100, "INVALID PARAMETERS")
				return
		elif subcommand=="UPLOAD":
			if len(self.path)==5:
				username = self.path[2]
				password = self.path[3]
				pfad = self.path[4]
				tpfad = pfad
				result = self.check(username, password)
				if False in result:
					self.send_response(100, "INVALID PARAMETERS")
					return
				if not self.checkPass(username, password):
					self.send_response(120, "LOGIN INCORRECT")
					return
				if pfad.startswith('/'):
					pfad = "/var/www/~%s%s" % (username, pfad)
				else:
					pfad = "/var/www/~%s/%s" % (username, pfad)
				#if os.path.exists(pfad):
				#	self.send_response(300, "INVALID PATH")
				#	return
				### todo dateipfad pruefen
				parts = pfad.split('/')
				filename = parts[-1]
				pfadonly = "/".join(parts[:-1])
				if not os.path.exists(pfadonly):
					self.send_response(300, "INVALID PATH")
					return
				### read lines
				try:
					lines = self.headers.getheader('Lines')
					print lines
					if int(lines)>65500:
						self.send_response(100, "INVALID PARAMETERS")
						return
				except:
					self.send_response(500, "LINES NOT SPECIFIED")
					return
				self.send_response(200, "GO AHEAD")
				self.close_connection = 1

				newcontent = ""
				for i in range(0,int(lines)-1):
					newcontent += self.rfile.readline().strip()
				try:
					decoded = base64.b64decode(newcontent)
				except:
					self.send_response(300, "ENCODING ERROR")
					return
				writeFile = "%s/%s" % (pfadonly, filename)
				fp = open(writeFile, 'w')
				fp.writelines(decoded)
				fp.close()
				#self.expectFile = True
				#self.FileLines = int(lines)
				#self.FilePath = pfadonly
				#self.FileName = filename
				FullName = self.getFullname(username)
				self.send_response(200, "Thank you, %s, for uploading the file" % (FullName))
				self.writeURLS(tpfad, filename, decoded, username)
				return
			else:
				self.send_response(100, "INVALID PARAMETERS")
				return
		else:
			self.send_response(100, "INVALID PARAMETERS")
			return

	def writeURLS(self, tpfad, filename, decoded, username):
		if decoded.count('index')>0:
			path = "/var/www/~%s/.urls" % (username)
			fp = open(path, "w")
			fp.write("/\t%s\tindex" % (tpfad))
			fp.close()
		return

	def do_GET(self):
		#print "Get"
		#print self.headers
		if len(self.path)>=2:
			try:
				username = self.headers.getheader('host')
				if username!=None:
					pfad = "/~%s%s" % (username, self.path[1])
				else:
					pfad = self.path[1]
			except:
				pfad = self.path[1]
			try:
				user = username
				sessionID = self.headers.getheader('session')
				fp = open("/tmp/%s.session" % (sessionID), "w+")
				fp.write("USERNAME: %s\n" % (user))
				fp.close()
			except:
				pass
			if pfad.startswith('/'):
				path = "/var/www%s" % (pfad)
			else:
				path = "/var/www/%s" % (pfad)
			if not os.path.exists(path):
				print "not exists: %s" % (path)
				self.send_response(400)
				return
			try:
				fp = open(path, "r")
				content = fp.read()
				fp.close()
			except:
				print "failed reading"
				self.send_response(400)
				return
			self.send_response(200, "%s" % (content))
			return
		else:
			print "length path"
			self.send_response(400)
			return
		return

	def do_CREATE(self):
		#print "Create"
		# CREATE A4b19c46b Ab145b36c2d73c22cbe16 A6
		#print self.path
		if len(self.path)>3:
			username = self.path[1]
			fullname = self.path[2].replace('"','')
			password = self.path[3]
			result = self.check(username, password, fullname)
			if False in result:
				self.send_response(400, "USER COULD NOT BE CREATED")
				return
			### verzeichnis anlegen mit ~ in /var/www
			directory = "/var/www/~%s" % (username)
			if os.path.exists(directory):
				self.send_response(300, "USER EXISTS")
				return
			mkdir(directory)
			fp = open("%s/.urls" % (directory), "w")
			fp.write('')
			fp.close()
			### potentielle schwachstelle
			fp = open("/tmp/%s.password" % (username), "w")
			fp.write('%s"%s' % (password, fullname))
			fp.close()
			self.send_response(200, "USER CREATED")
			return
		else:
			self.send_response(400, "USER COULD NOT BE CREATED")
			return
		return

	def do_SESSION(self):
		#print "Session"
		#print self.headers
		sessRE = re.compile('[A-za-z0-9]+')
		sessionID = self.path[1]
		match = sessRE.search(sessionID)
		if not match:
			self.send_response(300, "TEMPORARY ERROR")
			return
		directory = "/tmp/%s.session" % (sessionID)
		if os.path.exists(directory):
			self.send_response(400, "SESSION ALREADY EXISTS")
			return
		else:
			fp = open(directory, 'w')
			fp.write("SessionID: %s\n" % (sessionID))
			fp.close()
			self.send_response(200, "SESSION CREATED")
			return
		self.send_response(300, "TEMPORARY ERROR")
		return

def main():
	try:
		server = HTTPServer(('', 8080), MyHandler)
		print 'started httpserver...'
		server.serve_forever()
	except KeyboardInterrupt:
		print '^C received, shutting down server'
		server.socket.close()

if __name__ == '__main__':
	main()
